//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armstoragesync

import (
	"encoding/json"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore"
	"reflect"
)

// MarshalJSON implements the json.Marshaller interface for type CloudEndpointArray.
func (c CloudEndpointArray) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "value", c.Value)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type CloudEndpointChangeEnumerationActivity.
func (c CloudEndpointChangeEnumerationActivity) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "deletesProgressPercent", c.DeletesProgressPercent)
	populateTimeRFC3339(objectMap, "lastUpdatedTimestamp", c.LastUpdatedTimestamp)
	populate(objectMap, "minutesRemaining", c.MinutesRemaining)
	populate(objectMap, "operationState", c.OperationState)
	populate(objectMap, "processedDirectoriesCount", c.ProcessedDirectoriesCount)
	populate(objectMap, "processedFilesCount", c.ProcessedFilesCount)
	populate(objectMap, "progressPercent", c.ProgressPercent)
	populateTimeRFC3339(objectMap, "startedTimestamp", c.StartedTimestamp)
	populate(objectMap, "statusCode", c.StatusCode)
	populate(objectMap, "totalCountsState", c.TotalCountsState)
	populate(objectMap, "totalDirectoriesCount", c.TotalDirectoriesCount)
	populate(objectMap, "totalFilesCount", c.TotalFilesCount)
	populate(objectMap, "totalSizeBytes", c.TotalSizeBytes)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type CloudEndpointChangeEnumerationActivity.
func (c *CloudEndpointChangeEnumerationActivity) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "deletesProgressPercent":
			err = unpopulate(val, &c.DeletesProgressPercent)
			delete(rawMsg, key)
		case "lastUpdatedTimestamp":
			err = unpopulateTimeRFC3339(val, &c.LastUpdatedTimestamp)
			delete(rawMsg, key)
		case "minutesRemaining":
			err = unpopulate(val, &c.MinutesRemaining)
			delete(rawMsg, key)
		case "operationState":
			err = unpopulate(val, &c.OperationState)
			delete(rawMsg, key)
		case "processedDirectoriesCount":
			err = unpopulate(val, &c.ProcessedDirectoriesCount)
			delete(rawMsg, key)
		case "processedFilesCount":
			err = unpopulate(val, &c.ProcessedFilesCount)
			delete(rawMsg, key)
		case "progressPercent":
			err = unpopulate(val, &c.ProgressPercent)
			delete(rawMsg, key)
		case "startedTimestamp":
			err = unpopulateTimeRFC3339(val, &c.StartedTimestamp)
			delete(rawMsg, key)
		case "statusCode":
			err = unpopulate(val, &c.StatusCode)
			delete(rawMsg, key)
		case "totalCountsState":
			err = unpopulate(val, &c.TotalCountsState)
			delete(rawMsg, key)
		case "totalDirectoriesCount":
			err = unpopulate(val, &c.TotalDirectoriesCount)
			delete(rawMsg, key)
		case "totalFilesCount":
			err = unpopulate(val, &c.TotalFilesCount)
			delete(rawMsg, key)
		case "totalSizeBytes":
			err = unpopulate(val, &c.TotalSizeBytes)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type CloudEndpointChangeEnumerationStatus.
func (c CloudEndpointChangeEnumerationStatus) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "activity", c.Activity)
	populate(objectMap, "lastEnumerationStatus", c.LastEnumerationStatus)
	populateTimeRFC3339(objectMap, "lastUpdatedTimestamp", c.LastUpdatedTimestamp)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type CloudEndpointChangeEnumerationStatus.
func (c *CloudEndpointChangeEnumerationStatus) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "activity":
			err = unpopulate(val, &c.Activity)
			delete(rawMsg, key)
		case "lastEnumerationStatus":
			err = unpopulate(val, &c.LastEnumerationStatus)
			delete(rawMsg, key)
		case "lastUpdatedTimestamp":
			err = unpopulateTimeRFC3339(val, &c.LastUpdatedTimestamp)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type CloudEndpointLastChangeEnumerationStatus.
func (c CloudEndpointLastChangeEnumerationStatus) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populateTimeRFC3339(objectMap, "completedTimestamp", c.CompletedTimestamp)
	populate(objectMap, "namespaceDirectoriesCount", c.NamespaceDirectoriesCount)
	populate(objectMap, "namespaceFilesCount", c.NamespaceFilesCount)
	populate(objectMap, "namespaceSizeBytes", c.NamespaceSizeBytes)
	populateTimeRFC3339(objectMap, "nextRunTimestamp", c.NextRunTimestamp)
	populateTimeRFC3339(objectMap, "startedTimestamp", c.StartedTimestamp)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type CloudEndpointLastChangeEnumerationStatus.
func (c *CloudEndpointLastChangeEnumerationStatus) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "completedTimestamp":
			err = unpopulateTimeRFC3339(val, &c.CompletedTimestamp)
			delete(rawMsg, key)
		case "namespaceDirectoriesCount":
			err = unpopulate(val, &c.NamespaceDirectoriesCount)
			delete(rawMsg, key)
		case "namespaceFilesCount":
			err = unpopulate(val, &c.NamespaceFilesCount)
			delete(rawMsg, key)
		case "namespaceSizeBytes":
			err = unpopulate(val, &c.NamespaceSizeBytes)
			delete(rawMsg, key)
		case "nextRunTimestamp":
			err = unpopulateTimeRFC3339(val, &c.NextRunTimestamp)
			delete(rawMsg, key)
		case "startedTimestamp":
			err = unpopulateTimeRFC3339(val, &c.StartedTimestamp)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type CloudTieringCachePerformance.
func (c CloudTieringCachePerformance) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "cacheHitBytes", c.CacheHitBytes)
	populate(objectMap, "cacheHitBytesPercent", c.CacheHitBytesPercent)
	populate(objectMap, "cacheMissBytes", c.CacheMissBytes)
	populateTimeRFC3339(objectMap, "lastUpdatedTimestamp", c.LastUpdatedTimestamp)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type CloudTieringCachePerformance.
func (c *CloudTieringCachePerformance) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "cacheHitBytes":
			err = unpopulate(val, &c.CacheHitBytes)
			delete(rawMsg, key)
		case "cacheHitBytesPercent":
			err = unpopulate(val, &c.CacheHitBytesPercent)
			delete(rawMsg, key)
		case "cacheMissBytes":
			err = unpopulate(val, &c.CacheMissBytes)
			delete(rawMsg, key)
		case "lastUpdatedTimestamp":
			err = unpopulateTimeRFC3339(val, &c.LastUpdatedTimestamp)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type CloudTieringDatePolicyStatus.
func (c CloudTieringDatePolicyStatus) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populateTimeRFC3339(objectMap, "lastUpdatedTimestamp", c.LastUpdatedTimestamp)
	populateTimeRFC3339(objectMap, "tieredFilesMostRecentAccessTimestamp", c.TieredFilesMostRecentAccessTimestamp)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type CloudTieringDatePolicyStatus.
func (c *CloudTieringDatePolicyStatus) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "lastUpdatedTimestamp":
			err = unpopulateTimeRFC3339(val, &c.LastUpdatedTimestamp)
			delete(rawMsg, key)
		case "tieredFilesMostRecentAccessTimestamp":
			err = unpopulateTimeRFC3339(val, &c.TieredFilesMostRecentAccessTimestamp)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type CloudTieringFilesNotTiering.
func (c CloudTieringFilesNotTiering) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "errors", c.Errors)
	populateTimeRFC3339(objectMap, "lastUpdatedTimestamp", c.LastUpdatedTimestamp)
	populate(objectMap, "totalFileCount", c.TotalFileCount)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type CloudTieringFilesNotTiering.
func (c *CloudTieringFilesNotTiering) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "errors":
			err = unpopulate(val, &c.Errors)
			delete(rawMsg, key)
		case "lastUpdatedTimestamp":
			err = unpopulateTimeRFC3339(val, &c.LastUpdatedTimestamp)
			delete(rawMsg, key)
		case "totalFileCount":
			err = unpopulate(val, &c.TotalFileCount)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type CloudTieringSpaceSavings.
func (c CloudTieringSpaceSavings) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "cachedSizeBytes", c.CachedSizeBytes)
	populateTimeRFC3339(objectMap, "lastUpdatedTimestamp", c.LastUpdatedTimestamp)
	populate(objectMap, "spaceSavingsBytes", c.SpaceSavingsBytes)
	populate(objectMap, "spaceSavingsPercent", c.SpaceSavingsPercent)
	populate(objectMap, "totalSizeCloudBytes", c.TotalSizeCloudBytes)
	populate(objectMap, "volumeSizeBytes", c.VolumeSizeBytes)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type CloudTieringSpaceSavings.
func (c *CloudTieringSpaceSavings) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "cachedSizeBytes":
			err = unpopulate(val, &c.CachedSizeBytes)
			delete(rawMsg, key)
		case "lastUpdatedTimestamp":
			err = unpopulateTimeRFC3339(val, &c.LastUpdatedTimestamp)
			delete(rawMsg, key)
		case "spaceSavingsBytes":
			err = unpopulate(val, &c.SpaceSavingsBytes)
			delete(rawMsg, key)
		case "spaceSavingsPercent":
			err = unpopulate(val, &c.SpaceSavingsPercent)
			delete(rawMsg, key)
		case "totalSizeCloudBytes":
			err = unpopulate(val, &c.TotalSizeCloudBytes)
			delete(rawMsg, key)
		case "volumeSizeBytes":
			err = unpopulate(val, &c.VolumeSizeBytes)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type CloudTieringVolumeFreeSpacePolicyStatus.
func (c CloudTieringVolumeFreeSpacePolicyStatus) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "currentVolumeFreeSpacePercent", c.CurrentVolumeFreeSpacePercent)
	populate(objectMap, "effectiveVolumeFreeSpacePolicy", c.EffectiveVolumeFreeSpacePolicy)
	populateTimeRFC3339(objectMap, "lastUpdatedTimestamp", c.LastUpdatedTimestamp)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type CloudTieringVolumeFreeSpacePolicyStatus.
func (c *CloudTieringVolumeFreeSpacePolicyStatus) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "currentVolumeFreeSpacePercent":
			err = unpopulate(val, &c.CurrentVolumeFreeSpacePercent)
			delete(rawMsg, key)
		case "effectiveVolumeFreeSpacePolicy":
			err = unpopulate(val, &c.EffectiveVolumeFreeSpacePolicy)
			delete(rawMsg, key)
		case "lastUpdatedTimestamp":
			err = unpopulateTimeRFC3339(val, &c.LastUpdatedTimestamp)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type LocationOperationStatus.
func (l LocationOperationStatus) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populateTimeRFC3339(objectMap, "endTime", l.EndTime)
	populate(objectMap, "error", l.Error)
	populate(objectMap, "id", l.ID)
	populate(objectMap, "name", l.Name)
	populate(objectMap, "percentComplete", l.PercentComplete)
	populateTimeRFC3339(objectMap, "startTime", l.StartTime)
	populate(objectMap, "status", l.Status)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type LocationOperationStatus.
func (l *LocationOperationStatus) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "endTime":
			err = unpopulateTimeRFC3339(val, &l.EndTime)
			delete(rawMsg, key)
		case "error":
			err = unpopulate(val, &l.Error)
			delete(rawMsg, key)
		case "id":
			err = unpopulate(val, &l.ID)
			delete(rawMsg, key)
		case "name":
			err = unpopulate(val, &l.Name)
			delete(rawMsg, key)
		case "percentComplete":
			err = unpopulate(val, &l.PercentComplete)
			delete(rawMsg, key)
		case "startTime":
			err = unpopulateTimeRFC3339(val, &l.StartTime)
			delete(rawMsg, key)
		case "status":
			err = unpopulate(val, &l.Status)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type OperationEntityListResult.
func (o OperationEntityListResult) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "nextLink", o.NextLink)
	populate(objectMap, "value", o.Value)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type OperationResourceMetricSpecification.
func (o OperationResourceMetricSpecification) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "aggregationType", o.AggregationType)
	populate(objectMap, "dimensions", o.Dimensions)
	populate(objectMap, "displayDescription", o.DisplayDescription)
	populate(objectMap, "displayName", o.DisplayName)
	populate(objectMap, "fillGapWithZero", o.FillGapWithZero)
	populate(objectMap, "name", o.Name)
	populate(objectMap, "supportedAggregationTypes", o.SupportedAggregationTypes)
	populate(objectMap, "unit", o.Unit)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type OperationResourceServiceSpecification.
func (o OperationResourceServiceSpecification) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "metricSpecifications", o.MetricSpecifications)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type OperationStatus.
func (o OperationStatus) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populateTimeRFC3339(objectMap, "endTime", o.EndTime)
	populate(objectMap, "error", o.Error)
	populate(objectMap, "name", o.Name)
	populateTimeRFC3339(objectMap, "startTime", o.StartTime)
	populate(objectMap, "status", o.Status)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type OperationStatus.
func (o *OperationStatus) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "endTime":
			err = unpopulateTimeRFC3339(val, &o.EndTime)
			delete(rawMsg, key)
		case "error":
			err = unpopulate(val, &o.Error)
			delete(rawMsg, key)
		case "name":
			err = unpopulate(val, &o.Name)
			delete(rawMsg, key)
		case "startTime":
			err = unpopulateTimeRFC3339(val, &o.StartTime)
			delete(rawMsg, key)
		case "status":
			err = unpopulate(val, &o.Status)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type PostRestoreRequest.
func (p PostRestoreRequest) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "azureFileShareUri", p.AzureFileShareURI)
	populate(objectMap, "failedFileList", p.FailedFileList)
	populate(objectMap, "partition", p.Partition)
	populate(objectMap, "replicaGroup", p.ReplicaGroup)
	populate(objectMap, "requestId", p.RequestID)
	populate(objectMap, "restoreFileSpec", p.RestoreFileSpec)
	populate(objectMap, "sourceAzureFileShareUri", p.SourceAzureFileShareURI)
	populate(objectMap, "status", p.Status)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type PreRestoreRequest.
func (p PreRestoreRequest) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "azureFileShareUri", p.AzureFileShareURI)
	populate(objectMap, "backupMetadataPropertyBag", p.BackupMetadataPropertyBag)
	populate(objectMap, "partition", p.Partition)
	populate(objectMap, "pauseWaitForSyncDrainTimePeriodInSeconds", p.PauseWaitForSyncDrainTimePeriodInSeconds)
	populate(objectMap, "replicaGroup", p.ReplicaGroup)
	populate(objectMap, "requestId", p.RequestID)
	populate(objectMap, "restoreFileSpec", p.RestoreFileSpec)
	populate(objectMap, "sourceAzureFileShareUri", p.SourceAzureFileShareURI)
	populate(objectMap, "status", p.Status)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type PrivateEndpointConnectionListResult.
func (p PrivateEndpointConnectionListResult) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "value", p.Value)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type PrivateLinkResourceListResult.
func (p PrivateLinkResourceListResult) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "value", p.Value)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type PrivateLinkResourceProperties.
func (p PrivateLinkResourceProperties) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "groupId", p.GroupID)
	populate(objectMap, "requiredMembers", p.RequiredMembers)
	populate(objectMap, "requiredZoneNames", p.RequiredZoneNames)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type RegisteredServerArray.
func (r RegisteredServerArray) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "value", r.Value)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type RegisteredServerProperties.
func (r RegisteredServerProperties) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "agentVersion", r.AgentVersion)
	populateTimeRFC3339(objectMap, "agentVersionExpirationDate", r.AgentVersionExpirationDate)
	populate(objectMap, "agentVersionStatus", r.AgentVersionStatus)
	populate(objectMap, "clusterId", r.ClusterID)
	populate(objectMap, "clusterName", r.ClusterName)
	populate(objectMap, "discoveryEndpointUri", r.DiscoveryEndpointURI)
	populate(objectMap, "friendlyName", r.FriendlyName)
	populate(objectMap, "lastHeartBeat", r.LastHeartBeat)
	populate(objectMap, "lastOperationName", r.LastOperationName)
	populate(objectMap, "lastWorkflowId", r.LastWorkflowID)
	populate(objectMap, "managementEndpointUri", r.ManagementEndpointURI)
	populate(objectMap, "monitoringConfiguration", r.MonitoringConfiguration)
	populate(objectMap, "monitoringEndpointUri", r.MonitoringEndpointURI)
	populate(objectMap, "provisioningState", r.ProvisioningState)
	populate(objectMap, "resourceLocation", r.ResourceLocation)
	populate(objectMap, "serverCertificate", r.ServerCertificate)
	populate(objectMap, "serverId", r.ServerID)
	populate(objectMap, "serverManagementErrorCode", r.ServerManagementErrorCode)
	populate(objectMap, "serverName", r.ServerName)
	populate(objectMap, "serverOSVersion", r.ServerOSVersion)
	populate(objectMap, "serverRole", r.ServerRole)
	populate(objectMap, "serviceLocation", r.ServiceLocation)
	populate(objectMap, "storageSyncServiceUid", r.StorageSyncServiceUID)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type RegisteredServerProperties.
func (r *RegisteredServerProperties) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "agentVersion":
			err = unpopulate(val, &r.AgentVersion)
			delete(rawMsg, key)
		case "agentVersionExpirationDate":
			err = unpopulateTimeRFC3339(val, &r.AgentVersionExpirationDate)
			delete(rawMsg, key)
		case "agentVersionStatus":
			err = unpopulate(val, &r.AgentVersionStatus)
			delete(rawMsg, key)
		case "clusterId":
			err = unpopulate(val, &r.ClusterID)
			delete(rawMsg, key)
		case "clusterName":
			err = unpopulate(val, &r.ClusterName)
			delete(rawMsg, key)
		case "discoveryEndpointUri":
			err = unpopulate(val, &r.DiscoveryEndpointURI)
			delete(rawMsg, key)
		case "friendlyName":
			err = unpopulate(val, &r.FriendlyName)
			delete(rawMsg, key)
		case "lastHeartBeat":
			err = unpopulate(val, &r.LastHeartBeat)
			delete(rawMsg, key)
		case "lastOperationName":
			err = unpopulate(val, &r.LastOperationName)
			delete(rawMsg, key)
		case "lastWorkflowId":
			err = unpopulate(val, &r.LastWorkflowID)
			delete(rawMsg, key)
		case "managementEndpointUri":
			err = unpopulate(val, &r.ManagementEndpointURI)
			delete(rawMsg, key)
		case "monitoringConfiguration":
			err = unpopulate(val, &r.MonitoringConfiguration)
			delete(rawMsg, key)
		case "monitoringEndpointUri":
			err = unpopulate(val, &r.MonitoringEndpointURI)
			delete(rawMsg, key)
		case "provisioningState":
			err = unpopulate(val, &r.ProvisioningState)
			delete(rawMsg, key)
		case "resourceLocation":
			err = unpopulate(val, &r.ResourceLocation)
			delete(rawMsg, key)
		case "serverCertificate":
			err = unpopulate(val, &r.ServerCertificate)
			delete(rawMsg, key)
		case "serverId":
			err = unpopulate(val, &r.ServerID)
			delete(rawMsg, key)
		case "serverManagementErrorCode":
			err = unpopulate(val, &r.ServerManagementErrorCode)
			delete(rawMsg, key)
		case "serverName":
			err = unpopulate(val, &r.ServerName)
			delete(rawMsg, key)
		case "serverOSVersion":
			err = unpopulate(val, &r.ServerOSVersion)
			delete(rawMsg, key)
		case "serverRole":
			err = unpopulate(val, &r.ServerRole)
			delete(rawMsg, key)
		case "serviceLocation":
			err = unpopulate(val, &r.ServiceLocation)
			delete(rawMsg, key)
		case "storageSyncServiceUid":
			err = unpopulate(val, &r.StorageSyncServiceUID)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type ResourcesMoveInfo.
func (r ResourcesMoveInfo) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "resources", r.Resources)
	populate(objectMap, "targetResourceGroup", r.TargetResourceGroup)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type ServerEndpointArray.
func (s ServerEndpointArray) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "value", s.Value)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type ServerEndpointBackgroundDataDownloadActivity.
func (s ServerEndpointBackgroundDataDownloadActivity) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "downloadedBytes", s.DownloadedBytes)
	populate(objectMap, "percentProgress", s.PercentProgress)
	populateTimeRFC3339(objectMap, "startedTimestamp", s.StartedTimestamp)
	populateTimeRFC3339(objectMap, "timestamp", s.Timestamp)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ServerEndpointBackgroundDataDownloadActivity.
func (s *ServerEndpointBackgroundDataDownloadActivity) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "downloadedBytes":
			err = unpopulate(val, &s.DownloadedBytes)
			delete(rawMsg, key)
		case "percentProgress":
			err = unpopulate(val, &s.PercentProgress)
			delete(rawMsg, key)
		case "startedTimestamp":
			err = unpopulateTimeRFC3339(val, &s.StartedTimestamp)
			delete(rawMsg, key)
		case "timestamp":
			err = unpopulateTimeRFC3339(val, &s.Timestamp)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type ServerEndpointCloudTieringStatus.
func (s ServerEndpointCloudTieringStatus) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "cachePerformance", s.CachePerformance)
	populate(objectMap, "datePolicyStatus", s.DatePolicyStatus)
	populate(objectMap, "filesNotTiering", s.FilesNotTiering)
	populate(objectMap, "health", s.Health)
	populateTimeRFC3339(objectMap, "healthLastUpdatedTimestamp", s.HealthLastUpdatedTimestamp)
	populate(objectMap, "lastCloudTieringResult", s.LastCloudTieringResult)
	populateTimeRFC3339(objectMap, "lastSuccessTimestamp", s.LastSuccessTimestamp)
	populateTimeRFC3339(objectMap, "lastUpdatedTimestamp", s.LastUpdatedTimestamp)
	populate(objectMap, "spaceSavings", s.SpaceSavings)
	populate(objectMap, "volumeFreeSpacePolicyStatus", s.VolumeFreeSpacePolicyStatus)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ServerEndpointCloudTieringStatus.
func (s *ServerEndpointCloudTieringStatus) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "cachePerformance":
			err = unpopulate(val, &s.CachePerformance)
			delete(rawMsg, key)
		case "datePolicyStatus":
			err = unpopulate(val, &s.DatePolicyStatus)
			delete(rawMsg, key)
		case "filesNotTiering":
			err = unpopulate(val, &s.FilesNotTiering)
			delete(rawMsg, key)
		case "health":
			err = unpopulate(val, &s.Health)
			delete(rawMsg, key)
		case "healthLastUpdatedTimestamp":
			err = unpopulateTimeRFC3339(val, &s.HealthLastUpdatedTimestamp)
			delete(rawMsg, key)
		case "lastCloudTieringResult":
			err = unpopulate(val, &s.LastCloudTieringResult)
			delete(rawMsg, key)
		case "lastSuccessTimestamp":
			err = unpopulateTimeRFC3339(val, &s.LastSuccessTimestamp)
			delete(rawMsg, key)
		case "lastUpdatedTimestamp":
			err = unpopulateTimeRFC3339(val, &s.LastUpdatedTimestamp)
			delete(rawMsg, key)
		case "spaceSavings":
			err = unpopulate(val, &s.SpaceSavings)
			delete(rawMsg, key)
		case "volumeFreeSpacePolicyStatus":
			err = unpopulate(val, &s.VolumeFreeSpacePolicyStatus)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type ServerEndpointRecallStatus.
func (s ServerEndpointRecallStatus) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populateTimeRFC3339(objectMap, "lastUpdatedTimestamp", s.LastUpdatedTimestamp)
	populate(objectMap, "recallErrors", s.RecallErrors)
	populate(objectMap, "totalRecallErrorsCount", s.TotalRecallErrorsCount)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ServerEndpointRecallStatus.
func (s *ServerEndpointRecallStatus) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "lastUpdatedTimestamp":
			err = unpopulateTimeRFC3339(val, &s.LastUpdatedTimestamp)
			delete(rawMsg, key)
		case "recallErrors":
			err = unpopulate(val, &s.RecallErrors)
			delete(rawMsg, key)
		case "totalRecallErrorsCount":
			err = unpopulate(val, &s.TotalRecallErrorsCount)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type ServerEndpointSyncActivityStatus.
func (s ServerEndpointSyncActivityStatus) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "appliedBytes", s.AppliedBytes)
	populate(objectMap, "appliedItemCount", s.AppliedItemCount)
	populate(objectMap, "perItemErrorCount", s.PerItemErrorCount)
	populate(objectMap, "sessionMinutesRemaining", s.SessionMinutesRemaining)
	populate(objectMap, "syncMode", s.SyncMode)
	populateTimeRFC3339(objectMap, "timestamp", s.Timestamp)
	populate(objectMap, "totalBytes", s.TotalBytes)
	populate(objectMap, "totalItemCount", s.TotalItemCount)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ServerEndpointSyncActivityStatus.
func (s *ServerEndpointSyncActivityStatus) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "appliedBytes":
			err = unpopulate(val, &s.AppliedBytes)
			delete(rawMsg, key)
		case "appliedItemCount":
			err = unpopulate(val, &s.AppliedItemCount)
			delete(rawMsg, key)
		case "perItemErrorCount":
			err = unpopulate(val, &s.PerItemErrorCount)
			delete(rawMsg, key)
		case "sessionMinutesRemaining":
			err = unpopulate(val, &s.SessionMinutesRemaining)
			delete(rawMsg, key)
		case "syncMode":
			err = unpopulate(val, &s.SyncMode)
			delete(rawMsg, key)
		case "timestamp":
			err = unpopulateTimeRFC3339(val, &s.Timestamp)
			delete(rawMsg, key)
		case "totalBytes":
			err = unpopulate(val, &s.TotalBytes)
			delete(rawMsg, key)
		case "totalItemCount":
			err = unpopulate(val, &s.TotalItemCount)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type ServerEndpointSyncSessionStatus.
func (s ServerEndpointSyncSessionStatus) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "filesNotSyncingErrors", s.FilesNotSyncingErrors)
	populate(objectMap, "lastSyncMode", s.LastSyncMode)
	populate(objectMap, "lastSyncPerItemErrorCount", s.LastSyncPerItemErrorCount)
	populate(objectMap, "lastSyncResult", s.LastSyncResult)
	populateTimeRFC3339(objectMap, "lastSyncSuccessTimestamp", s.LastSyncSuccessTimestamp)
	populateTimeRFC3339(objectMap, "lastSyncTimestamp", s.LastSyncTimestamp)
	populate(objectMap, "persistentFilesNotSyncingCount", s.PersistentFilesNotSyncingCount)
	populate(objectMap, "transientFilesNotSyncingCount", s.TransientFilesNotSyncingCount)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ServerEndpointSyncSessionStatus.
func (s *ServerEndpointSyncSessionStatus) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "filesNotSyncingErrors":
			err = unpopulate(val, &s.FilesNotSyncingErrors)
			delete(rawMsg, key)
		case "lastSyncMode":
			err = unpopulate(val, &s.LastSyncMode)
			delete(rawMsg, key)
		case "lastSyncPerItemErrorCount":
			err = unpopulate(val, &s.LastSyncPerItemErrorCount)
			delete(rawMsg, key)
		case "lastSyncResult":
			err = unpopulate(val, &s.LastSyncResult)
			delete(rawMsg, key)
		case "lastSyncSuccessTimestamp":
			err = unpopulateTimeRFC3339(val, &s.LastSyncSuccessTimestamp)
			delete(rawMsg, key)
		case "lastSyncTimestamp":
			err = unpopulateTimeRFC3339(val, &s.LastSyncTimestamp)
			delete(rawMsg, key)
		case "persistentFilesNotSyncingCount":
			err = unpopulate(val, &s.PersistentFilesNotSyncingCount)
			delete(rawMsg, key)
		case "transientFilesNotSyncingCount":
			err = unpopulate(val, &s.TransientFilesNotSyncingCount)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type ServerEndpointSyncStatus.
func (s ServerEndpointSyncStatus) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "backgroundDataDownloadActivity", s.BackgroundDataDownloadActivity)
	populate(objectMap, "combinedHealth", s.CombinedHealth)
	populate(objectMap, "downloadActivity", s.DownloadActivity)
	populate(objectMap, "downloadHealth", s.DownloadHealth)
	populate(objectMap, "downloadStatus", s.DownloadStatus)
	populateTimeRFC3339(objectMap, "lastUpdatedTimestamp", s.LastUpdatedTimestamp)
	populate(objectMap, "offlineDataTransferStatus", s.OfflineDataTransferStatus)
	populate(objectMap, "syncActivity", s.SyncActivity)
	populate(objectMap, "totalPersistentFilesNotSyncingCount", s.TotalPersistentFilesNotSyncingCount)
	populate(objectMap, "uploadActivity", s.UploadActivity)
	populate(objectMap, "uploadHealth", s.UploadHealth)
	populate(objectMap, "uploadStatus", s.UploadStatus)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ServerEndpointSyncStatus.
func (s *ServerEndpointSyncStatus) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "backgroundDataDownloadActivity":
			err = unpopulate(val, &s.BackgroundDataDownloadActivity)
			delete(rawMsg, key)
		case "combinedHealth":
			err = unpopulate(val, &s.CombinedHealth)
			delete(rawMsg, key)
		case "downloadActivity":
			err = unpopulate(val, &s.DownloadActivity)
			delete(rawMsg, key)
		case "downloadHealth":
			err = unpopulate(val, &s.DownloadHealth)
			delete(rawMsg, key)
		case "downloadStatus":
			err = unpopulate(val, &s.DownloadStatus)
			delete(rawMsg, key)
		case "lastUpdatedTimestamp":
			err = unpopulateTimeRFC3339(val, &s.LastUpdatedTimestamp)
			delete(rawMsg, key)
		case "offlineDataTransferStatus":
			err = unpopulate(val, &s.OfflineDataTransferStatus)
			delete(rawMsg, key)
		case "syncActivity":
			err = unpopulate(val, &s.SyncActivity)
			delete(rawMsg, key)
		case "totalPersistentFilesNotSyncingCount":
			err = unpopulate(val, &s.TotalPersistentFilesNotSyncingCount)
			delete(rawMsg, key)
		case "uploadActivity":
			err = unpopulate(val, &s.UploadActivity)
			delete(rawMsg, key)
		case "uploadHealth":
			err = unpopulate(val, &s.UploadHealth)
			delete(rawMsg, key)
		case "uploadStatus":
			err = unpopulate(val, &s.UploadStatus)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type ServerEndpointUpdateParameters.
func (s ServerEndpointUpdateParameters) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "properties", s.Properties)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type Service.
func (s Service) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "id", s.ID)
	populate(objectMap, "location", s.Location)
	populate(objectMap, "name", s.Name)
	populate(objectMap, "properties", s.Properties)
	populate(objectMap, "systemData", s.SystemData)
	populate(objectMap, "tags", s.Tags)
	populate(objectMap, "type", s.Type)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type ServiceArray.
func (s ServiceArray) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "value", s.Value)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type ServiceCreateParameters.
func (s ServiceCreateParameters) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "location", s.Location)
	populate(objectMap, "properties", s.Properties)
	populate(objectMap, "tags", s.Tags)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type ServiceProperties.
func (s ServiceProperties) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "incomingTrafficPolicy", s.IncomingTrafficPolicy)
	populate(objectMap, "lastOperationName", s.LastOperationName)
	populate(objectMap, "lastWorkflowId", s.LastWorkflowID)
	populate(objectMap, "privateEndpointConnections", s.PrivateEndpointConnections)
	populate(objectMap, "provisioningState", s.ProvisioningState)
	populate(objectMap, "storageSyncServiceStatus", s.StorageSyncServiceStatus)
	populate(objectMap, "storageSyncServiceUid", s.StorageSyncServiceUID)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type ServiceUpdateParameters.
func (s ServiceUpdateParameters) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "properties", s.Properties)
	populate(objectMap, "tags", s.Tags)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type SyncGroupArray.
func (s SyncGroupArray) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "value", s.Value)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type SystemData.
func (s SystemData) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populateTimeRFC3339(objectMap, "createdAt", s.CreatedAt)
	populate(objectMap, "createdBy", s.CreatedBy)
	populate(objectMap, "createdByType", s.CreatedByType)
	populateTimeRFC3339(objectMap, "lastModifiedAt", s.LastModifiedAt)
	populate(objectMap, "lastModifiedBy", s.LastModifiedBy)
	populate(objectMap, "lastModifiedByType", s.LastModifiedByType)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type SystemData.
func (s *SystemData) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "createdAt":
			err = unpopulateTimeRFC3339(val, &s.CreatedAt)
			delete(rawMsg, key)
		case "createdBy":
			err = unpopulate(val, &s.CreatedBy)
			delete(rawMsg, key)
		case "createdByType":
			err = unpopulate(val, &s.CreatedByType)
			delete(rawMsg, key)
		case "lastModifiedAt":
			err = unpopulateTimeRFC3339(val, &s.LastModifiedAt)
			delete(rawMsg, key)
		case "lastModifiedBy":
			err = unpopulate(val, &s.LastModifiedBy)
			delete(rawMsg, key)
		case "lastModifiedByType":
			err = unpopulate(val, &s.LastModifiedByType)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

// MarshalJSON implements the json.Marshaller interface for type TrackedResource.
func (t TrackedResource) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "id", t.ID)
	populate(objectMap, "location", t.Location)
	populate(objectMap, "name", t.Name)
	populate(objectMap, "systemData", t.SystemData)
	populate(objectMap, "tags", t.Tags)
	populate(objectMap, "type", t.Type)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type TriggerChangeDetectionParameters.
func (t TriggerChangeDetectionParameters) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "changeDetectionMode", t.ChangeDetectionMode)
	populate(objectMap, "directoryPath", t.DirectoryPath)
	populate(objectMap, "paths", t.Paths)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type WorkflowArray.
func (w WorkflowArray) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "value", w.Value)
	return json.Marshal(objectMap)
}

// MarshalJSON implements the json.Marshaller interface for type WorkflowProperties.
func (w WorkflowProperties) MarshalJSON() ([]byte, error) {
	objectMap := make(map[string]interface{})
	populate(objectMap, "commandName", w.CommandName)
	populateTimeRFC3339(objectMap, "createdTimestamp", w.CreatedTimestamp)
	populate(objectMap, "lastOperationId", w.LastOperationID)
	populateTimeRFC3339(objectMap, "lastStatusTimestamp", w.LastStatusTimestamp)
	populate(objectMap, "lastStepName", w.LastStepName)
	populate(objectMap, "operation", w.Operation)
	populate(objectMap, "status", w.Status)
	populate(objectMap, "steps", w.Steps)
	return json.Marshal(objectMap)
}

// UnmarshalJSON implements the json.Unmarshaller interface for type WorkflowProperties.
func (w *WorkflowProperties) UnmarshalJSON(data []byte) error {
	var rawMsg map[string]json.RawMessage
	if err := json.Unmarshal(data, &rawMsg); err != nil {
		return err
	}
	for key, val := range rawMsg {
		var err error
		switch key {
		case "commandName":
			err = unpopulate(val, &w.CommandName)
			delete(rawMsg, key)
		case "createdTimestamp":
			err = unpopulateTimeRFC3339(val, &w.CreatedTimestamp)
			delete(rawMsg, key)
		case "lastOperationId":
			err = unpopulate(val, &w.LastOperationID)
			delete(rawMsg, key)
		case "lastStatusTimestamp":
			err = unpopulateTimeRFC3339(val, &w.LastStatusTimestamp)
			delete(rawMsg, key)
		case "lastStepName":
			err = unpopulate(val, &w.LastStepName)
			delete(rawMsg, key)
		case "operation":
			err = unpopulate(val, &w.Operation)
			delete(rawMsg, key)
		case "status":
			err = unpopulate(val, &w.Status)
			delete(rawMsg, key)
		case "steps":
			err = unpopulate(val, &w.Steps)
			delete(rawMsg, key)
		}
		if err != nil {
			return err
		}
	}
	return nil
}

func populate(m map[string]interface{}, k string, v interface{}) {
	if v == nil {
		return
	} else if azcore.IsNullValue(v) {
		m[k] = nil
	} else if !reflect.ValueOf(v).IsNil() {
		m[k] = v
	}
}

func unpopulate(data json.RawMessage, v interface{}) error {
	if data == nil {
		return nil
	}
	return json.Unmarshal(data, v)
}
